import os


class ProcessParser:
    command_output = []
    user_processes = []

    def load(self):
        list_jobs = os.popen("ps xao user,pid,sid,uid,stime,command")
        lines = list_jobs.read().split("\n")
        self.command_output = [line.split(maxsplit=5) for line in lines]
        self.command_output.pop(0)
        self.command_output.pop()
        list_jobs.close()
        return self

    def load_test_file(self):
        with open("./test_files/dc_psout", "r") as job_file:
            job = job_file.readline()
            while job:
                job = job_file.readline()
                self.command_output.append(job.split(maxsplit=5))
        return self

    def isolate_important_processes(self):
        i = 0
        processes = []
        for proc in self.command_output:
            if proc:
                if int(proc[3]) >= 500:
                    processes.append(proc)
        self.user_processes = processes

    def parse(self, jobs):
        self.isolate_important_processes()
        processes = {}
        for proc in self.user_processes:
            proc_dict = {
                "user": proc[0],
                "pid": proc[1],
                "sid": proc[2],
                "uid": proc[3],
                "stime": proc[4],
                "time": 0,
                "command": proc[5]
            }
            processes[f"{proc[0]}_{proc[1]}"] = proc_dict
        for line in self.user_processes:
            for job in jobs:
                if job[1] == line[2]:
                    processes[f"{line[0]}_{line[1]}"]["job"] = job
        return processes
